Hướng dẫn xử lý ngoại lệ trong Java - Java Exception Handling
Công ty Vĩnh Cửu tuyển dụng lập trình viên Java

1- Exception là gì?

Trước hết chúng ta hãy xem một ví dụ minh họa sau:
Trong ví dụ này có một đoạn code lỗi nguyên nhân do phép chia cho 0. Việc chia cho 0 gây ra ngoại lệ: ArithmeticException
HelloException.java
package org.o7planning.tutorial.exception;

public class HelloException {

  public static void main(String[] args) {

      System.out.println("Three");

      // Phép chia này hoàn toàn không có vấn đề.
      int value = 10 / 2;

      System.out.println("Two");

      // Phép chia này cũng vậy
      value = 10 / 1;

      System.out.println("One");

      // Phép chia này có vấn đề, chia cho 0.
      // Lỗi đã xẩy ra tại đây.
      value = 10 / 0;

      // Và dòng code dưới đây sẽ không được thực hiện.
      System.out.println("Let's go!");

  }

}
Kết quả chạy ví dụ:
Bạn có thể thấy thông báo lỗi trên màn hình Console, thông báo lỗi rất rõ ràng, xẩy ra ở dòng thứ mấy trên code.
Hãy xem luồng đi của chương trình qua hình minh họa dưới đây.
  • Chương trình đã chạy hoàn toàn bình thường từ các bước (1),(2) cho tới (5)
  • Bước thứ (6) xẩy ra vấn đề khi chia cho 0.
  • Chương trình đã nhẩy ra khỏi hàm main, và dòng code thứ (7) đã không được thực hiện.

Chúng ta sẽ sửa code của ví dụ trên.

HelloCatchException.java
package org.o7planning.tutorial.exception;

public class HelloCatchException {

   public static void main(String[] args) {

       System.out.println("Three");

       // Phép chia này hoàn toàn không có vấn đề.
       int value = 10 / 2;

       System.out.println("Two");

       // Phép chia này cũng vậy
       value = 10 / 1;

       System.out.println("One");

       try {
           // Phép chia này có vấn đề, chia cho 0.
           // Lỗi đã xẩy ra tại đây.
           value = 10 / 0;

           // Dòng code này sẽ không được chạy.
           System.out.println("Value =" + value);

       } catch (ArithmeticException e) {

           // Các dòng lệnh trong catch được thực thi
           System.out.println("Error: " + e.getMessage());

           // Các dòng lệnh trong catch được thực thi
           System.out.println("Ignore...");

       }

       // Dòng lệnh này được thực hiện.
       System.out.println("Let's go!");

   }

}
Và kết quả chạy ví dụ:
Chúng ta sẽ giải thích bằng hình minh họa dưới đây về luồng đi của chương trình.
  • Các bước (1)-(5) hoàn toàn bình thường.
  • Ngoại lệ xẩy ra tại bước (6), vấn đề chia cho 0.
  • Lập tức nó nhẩy vào thực thi lệnh trong khối catch, bước (7) bị bỏ qua.
  • Bước (8),(9) được thực hiện.
  • Bước (10) được thực hiện.

2- Sơ đồ phân cấp

Đây là mô hình sơ đồ phân cấp của Exception trong java.
  • Class ở mức cao nhất là Throwable
  • Hai class con trực tiếp là Error Exception.
Trong nhánh Exception có một nhánh con RuntimeException là các ngoại lệ sẽ không được java kiểm tra trong thời điểm biên dịch.Ý nghĩa của được kiểm tra và không được kiểm tra tại thời điểm biên dịch sẽ được minh họa trong các ví dụ phần sau.

Chú ý: Các class tùy biến của bạn nên viết thừa kế từ 2 nhánh Error hoặc Exception, không viết thừa kế trực tiếp từ Throwable.

Error

 Khi liên kết động thất bại, hoặc trong máy ảo xẩy ra một vấn đề nghiêm trọng, nó sẽ ném ra một Error. Các chương trình Java điển hình không nên bắt lỗi (Error). Ngoài ra, nó không chắc rằng các chương trình Java điển hình sẽ bao giờ ném lỗi

Ví dụ về liên kết động: Chẳng hạn như gọi đến thư viện mà thiếu class, hoặc thiếu method,... trong trường hợp vậy Error sẽ bị ném ra.

Exception

  Hầu hết các chương trình ném và bắt các đối tượng xuất phát từ lớp ngoại lệ. Trường hợp ngoại lệ cho thấy một vấn đề xảy ra nhưng vấn đề không phải là một vấn đề mang tính hệ thống nghiêm trọng. Hầu hết các chương trình bạn viết sẽ ném và bắt ngoại lệ.
     Các lớp ngoại lệ có nhiều con cháu được định nghĩa trong gói Java. Những hậu duệ cho nhiều loại hình trường hợp ngoại lệ có thể xảy ra. Ví dụ, NegativeArraySizeException được ném ra khi bạn cố gắng tạo một mảng mà lại có số phần tử âm.

    Một class ngoại lệ con có ý nghĩa đặc biệt trong ngôn ngữ Java: RuntimeException.

Runtime Exception

Class RuntimeException đại diện cho trường hợp ngoại lệ xảy ra trong thời gian chạy chương trình. Một ví dụ về một ngoại lệ thời gian chạy là NullPointerException, xảy ra khi một bạn truy cập vào method hoặc field một đối tượng thông qua một tham chiếu null. Với các ngoại lệ kiểu này người ta thường kiểm tra để đảm bảo nó sẽ không xẩy ra hơn là tìm bắt nó.

      Bởi vì trường hợp ngoại lệ thời gian chạy rất phổ biến và cố gắng bắt hoặc chỉ định tất cả chúng là cách làm không hiệu quả. Trình biên dịch của Java không kiểm tra các ngoại lệ này trong quá trình biên dịch code.

     Java định nghĩa một vài lớp RuntimeException. Bạn có thể bắt (Catch) những trường hợp ngoại lệ này như cách bắt các ngoại lệ thông thường khác. Các method mà trong nó có thể ném ra RuntimeException cũng không đòi hỏi phải khai báo trên định nghĩa của method. Ngoài ra, bạn có thể tạo lớp con RuntimeException của riêng bạn.

3- Bắt ngoại lệ thông qua try-catch

Chúng ta viết một exception thừa kế từ class Exception.
AgeException.java
package org.o7planning.tutorial.exception.basic;

public class AgeException extends Exception {

  public AgeException(String message) {
      super(message);
  }

}
TooYoungException.java
package org.o7planning.tutorial.exception.basic;

public class TooYoungException extends AgeException {

 public TooYoungException(String message) {
     super(message);
 }

}
TooOldException.java
package org.o7planning.tutorial.exception.basic;

public class TooOldException extends AgeException {

 public TooOldException(String message) {
     super(message);
 }

}
Và class AgeUtils có method tĩnh dùng cho việc kiểm tra tuổi.
AgeUtils.java
package org.o7planning.tutorial.exception.basic;

public class AgeUtils {

  // Method này làm nhiệm vụ kiểm tra tuổi.
  // Nếu tuổi nhỏ hơn 18 method sẽ ném ra ngoại lệ TooYoungException
  // Nếu tuổi lớn hơn 40 method sẽ ném ra ngoại lệ TooOldException
  public static void checkAge(int age) throws TooYoungException,
          TooOldException {
      if (age < 18) {
          // Nếu tuổi nhỏ hơn 18, ngoại lệ sẽ được ném ra
          // Method này kết thúc tại đây.
          throw new TooYoungException("Age " + age + " too young");
      } else if (age > 40) {
          // Nếu tuổi lớn hơn 40, ngoại lệ sẽ được ném ra.
          // Method này kết thúc tại đây.
          throw new TooOldException("Age " + age + " too old");
      }
      // Nếu tuổi nằm trong khoảng 18-40.
      // Đoạn code này sẽ được chạy.
      System.out.println("Age " + age + " OK!");
  }
}

Checked Exception và Unchecked Exception:

  • AgeException là con của Exception, TooOldExceptionTooYoungException là 2 class con trực tiếp của AgeException, nên chúng là các "Checked Exception"
  • Trong method AgeUtils.checkAge(int) có ném ra ngoài các ngoại lệ này vì vậy trên khai báo của method bạn cần phải liệt kê chúng thông qua từ khóa "throws". Hoặc bạn có thể khai báo ném ra ở mức tổng quát hơn
    • throws Exception.
  • Tại các nơi sử dụng AgeUtils.checkAge(int) cũng phải có sử lý để bắt các ngoại lệ đó, hoặc tiếp tục ném ra vòng ngoài.
"Checked exception" sẽ được "Java Compiler" kiểm tra.
Bạn có hai sự lựa chọn sử lý:
  1. Ném tiếp ra vòng ngoài
  2. Thực hiện việc bắt và sử lý ngoại lệ thông qua try-catch.
TryCatchDemo1.java
package org.o7planning.tutorial.exception.basic;

public class TryCatchDemo1 {

  public static void main(String[] args) {

      // Bắt đầu tuyển dụng
      System.out.println("Start Recruiting ...");
      // Kiểm tra tuổi của bạn.
      System.out.println("Check your Age");
      int age = 50;

      try {

          AgeUtils.checkAge(age);

          System.out.println("You pass!");

      } catch (TooYoungException e) {

          // Làm gì đó tại đây ..
          System.out.println("You are too young, not pass!");
          System.out.println(e.getMessage());

      } catch (TooOldException e) {

          // Làm gì đó tại đây
          System.out.println("You are too old, not pass!");
          System.out.println(e.getMessage());

      }

  }
}
Ví dụ dưới đây, chúng ta sẽ gộp bắt các ngoại lệ thông qua ngoại lệ ở cấp cao hơn. Ở cấp cao hơn nó sẽ tóm được ngoại lệ đó và tất cả các ngoại lệ con.
TryCatchDemo2.java
package org.o7planning.tutorial.exception.basic;

public class TryCatchDemo2 {

  public static void main(String[] args) {

      // Bắt đầu tuyển dụng
      System.out.println("Start Recruiting ...");
      // Kiểm tra tuổi của bạn.
      System.out.println("Check your Age");
      int age = 15;

      try {
          // Chỗ này có thể bị ngoại lệ TooOldException,
          // hoặc TooYoungException
          AgeUtils.checkAge(age);

          System.out.println("You pass!");

      } catch (AgeException e) {
          // Nếu có ngoại lệ xẩy ra, kiểu AgeException
          // Khối catch này sẽ được chạy

          System.out.println("Your age invalid, you not pass");
          System.out.println(e.getMessage());

      }
  }
}
Bạn cũng có thể gộp sử lý các ngoại lệ khác nhau vào cùng một khối catch để sử lý nếu chúng có cách sử lý giống nhau trong logic chương trình của bạn.
TryCatchDemo3.java
package org.o7planning.tutorial.exception.basic;

public class TryCatchDemo3 {

  public static void main(String[] args) {

      // Bắt đầu tuyển dụng
      System.out.println("Start Recruiting ...");
      // Kiểm tra tuổi của bạn.
      System.out.println("Check your Age");
      int age = 15;

      try {
          // Chỗ này có thể bị ngoại lệ TooOldException,
          // hoặc TooYoungException
          AgeUtils.checkAge(age);

          System.out.println("You pass!");

      } catch (TooYoungException | TooOldException e) {
          // Gộp 2 ngoại lệ trong cùng một khối catch

          System.out.println("Your age invalid, you not pass");
          System.out.println(e.getMessage());

      }
  }
}

4- Khối try-catch-finally

Trên kia chúng ta đã làm quen với việc bắt lỗi thông qua khối try-catch. Việc sử lý ngoại lệ đầy đủ là try-catch-finally.
try {

   // Làm gì đó tại đây

} catch (Exception1 e) {

   // Làm gì đó tại đây

} catch (Exception2 e) {

   // Làm gì đó tại đây

} finally {

   // Khối finally luôn luôn được thực thi
   // Làm gì đó tại đây.

}
TryCatchFinallyDemo.java
package org.o7planning.tutorial.exception.basic;

public class TryCatchFinallyDemo {

   public static void main(String[] args) {

       String text = "001234A2";

       int value = toInteger(text);

       System.out.println("Value= " + value);

   }

   public static int toInteger(String text) {
       try {

           System.out.println("Begin parse text: " + text);

           // Tại đây có thể phát sinh ngoại lệ NumberFormatException
           int value = Integer.parseInt(text);

           return value;

       } catch (NumberFormatException e) {

           // Trong trường hợp 'text' không phải là số.
           // Khối catch này sẽ được thực thi.
           System.out.println("Number format exception " + e.getMessage());

           // NumberFormatException xẩy ra, trả về 0.
           return 0;

       } finally {

           System.out.println("End parse text: " + text);

       }
   }

}
Đây là sơ luồng đi của chương trình. Khối finally luôn được thực thi.

5- Gói một Exception trong một Exception khác

Chúng ta cần một vài class tham gia vào ví dụ này:
  • Person: Mô phỏng một người tham gia tuyển dụng vào công ty với các thông tin
    • Tên, tuổi, giới tính.
  • GenderException: Ngoại lệ giới tính.
  • ValidateException: Ngoại lệ đánh giá thí sinh.
  • ValidateUtils: Class có method tĩnh đánh giá thí sinh đủ tiêu chuẩn không.
    • Tiêu chuẩn là những người độ tuổi 18-40
    • Và là Nam.
Person.java
package org.o7planning.tutorial.exception.wrap;

public class Person {

  public static final String MALE = "male";
  public static final String FEMALE = "female";

  private String name;
  private String gender;
  private int age;

  public Person(String name, String gender, int age) {
      this.name = name;
      this.gender = gender;
      this.age = age;
  }

  public String getName() {
      return name;
  }

  public void setName(String name) {
      this.name = name;
  }

  public String getGender() {
      return gender;
  }

  public void setGender(String gender) {
      this.gender = gender;
  }

  public int getAge() {
      return age;
  }

  public void setAge(int age) {
      this.age = age;
  }
}
GenderException.java
package org.o7planning.tutorial.exception.wrap;

// Ngoại lệ giới tính.
public class GenderException extends Exception {

     public GenderException(String message)  {
         super(message);
     }
}
Class ValidateException bao lấy một Exception khác.
ValidateException.java
package org.o7planning.tutorial.exception.wrap;

public class ValidateException extends Exception {
   
   // Gói Exception trong một Exception khác
   public ValidateException(Exception e)  {
       super(e);
   }

}
ValidateUtils.java
package org.o7planning.tutorial.exception.wrap;

import org.o7planning.tutorial.exception.basic.AgeUtils;

public class ValidateUtils {

   // Method kiểm tra đầu vào của người tuyển dụng.
   public static void checkPerson(Person person) throws ValidateException {
       try {

           // Kiểm tra tuổi.
           // Hợp lệ là trong khoảng 18-40
           // Method này có thể ném ra TooOldException,TooYoungException.
           AgeUtils.checkAge(person.getAge());

       } catch (Exception e) {

           // Nếu không hợp lệ
           // Gói ngoại lệ này bằng ValidateException
           throw new ValidateException(e);

       }

       // Nếu người đó là Nữ, nghĩa là không hợp lệ.
       if (person.getGender().equals(Person.FEMALE)) {

           GenderException e = new GenderException("Do not accept women");
           throw new ValidateException(e);

       }
   }

}
WrapperExceptionDemo.java
package org.o7planning.tutorial.exception.wrap;

public class WrapperExceptionDemo {

   public static void main(String[] args) {
       
       // Một người tham gia tuyển dụng.
       Person person = new Person("Marry", Person.FEMALE, 20);

       try {

           // Ngoại lệ có thể xẩy ra tại đây.
           ValidateUtils.checkPerson(person);

       } catch (ValidateException wrap) {

           // Lấy ra nguyên nhân thực sự.
           // Mà có thể là TooYoungException, TooOldException, GenderException
           Exception cause = (Exception) wrap.getCause();

           if (cause != null) {
               System.out.println("Not pass, cause: " + cause.getMessage());
           } else {
               System.out.println(wrap.getMessage());
           }

       }
   }

}

6- RuntimeException và các class con

Class RuntimeException và các class con, cháu của nó đều là các "Unchecked exception". Nó không được bộ dịch java kiểm tra trong thời gian biên dịch. Trong một vài tình huống bạn có thể viết các exception của mình thừa kế từ nhánh này. Có một số ngoại lệ trong nhánh này sẵn có trong java mà bạn cần phải để mắt tới nó.

Dưới đây là một vài class thuộc nhánh RuntimeException (Tất nhiên không phải là tất cả).
Chúng ta thử một vài ví dụ sử lý các ngoại lệ kiểu này:

6.1- NullPointerException

Đây là một trong các ngoại lệ thông dụng nhất, và hay gây ra lỗi cho chương trình. Ngoại lệ được ném ra khi bạn gọi hàm hoặc truy cập vào các trường của một đối tượng chưa được khởi tạo (đối tượng null).
NullPointerExceptionDemo.java
package org.o7planning.tutorial.exception.runtime;

public class NullPointerExceptionDemo {

    // Ví dụ đây là một method mà có thể trả về chuỗi null.
    public static String getString() {
        if (1 == 2) {
            return "1==2 !!";
        }
        return null;
    }

    public static void main(String[] args) {

        // Đây là một đối tượng có tham chiếu khác null.
        String text1 = "Hello exception";

        // Gọi hàm lấy ra độ dài chuỗi.
        int length = text1.length();

        System.out.println("Length text1 = " + length);

        // Đây là một đối tượng có tham chiếu null.
        String text2 = getString();

        // Gọi hàm lấy ra độ dài chuỗi.
        // NullPointerException sẽ xẩy ra tại đây.
        // Nó là ngoại lệ xuất hiện tại thời gian chạy.
        // Bộ dịch Java ko bắt buộc bạn phải sử lý nó.
        length = text2.length();

        System.out.println("Finish!");
    }

}
Kết quả chạy ví dụ:
Trong thực tế giống việc sử lý các ngoại lệ khác, bạn có thể sử dụng try-catch để bắt ngoại lệ này mà sử lý. Tuy nhiên, đó là cách máy móc, thông thường chúng ta nên kiểm tra để đảm bảo rằng đối tượng là khác null trước khi sử dụng nó.

Bạn có thể sửa code trên giống dưới đây, để tránh NullPointerException:
// Đây là một đối tượng có tham chiếu null.
String text2 = getString();

// Kiểm tra để đảm bảo rằng text2 là khác null
// Điều  này tránh NullPointerException
// Thay vì máy móc sử dụng try-catch.
if (text2 != null) {
  length = text2.length();
}

6.2- ArrayIndexOfBoundException

Đây là ngoại lệ nó được ném ra khi bạn cố truy cập vào phần tử có chỉ số không hợp lệ trên mảng. Chẳng hạn mảng có 10 phần tử, mà bạn lại truy cập  vào phần tử có chỉ số 20.
ArrayIndexOfBoundsExceptionDemo.java
package org.o7planning.tutorial.exception.runtime;

public class ArrayIndexOfBoundsExceptionDemo {

   public static void main(String[] args) {

       String[] strs = new String[] { "One", "Two", "Three" };

       // Truy cập vào phần tử có chỉ số 0.
       String str1 = strs[0];

       System.out.println("String at 0 = " + str1);

       // Truy cập vào phần tử có chỉ số 5
       // ArrayIndexOfBoundsException xẩy ra tại đây.
       String str2 = strs[5];

       System.out.println("String at 5 = " + str2);

   }

}
Để tránh ArrayIndexOfBoundsException bạn nên kiểm tra mảng thay vì sử dụng try-catch.
if (strs.length > 5) {
   String str2 = strs[5];
   System.out.println("String at 5 = " + str2);
} else {
   System.out.println("No elements with index 5");
}